Index: java/main/src/main/java/com/framsticks/gui/Browser.java
===================================================================
--- java/main/src/main/java/com/framsticks/gui/Browser.java	(revision 103)
+++ java/main/src/main/java/com/framsticks/gui/Browser.java	(revision 105)
@@ -4,5 +4,4 @@
 import com.framsticks.communication.queries.NeedFile;
 import com.framsticks.communication.queries.NeedFileAcceptor;
-import com.framsticks.core.*;
 import com.framsticks.gui.console.Console;
 import com.framsticks.gui.console.DirectConsole;
@@ -16,10 +15,12 @@
 import com.framsticks.parsers.FileSource;
 import com.framsticks.remote.RemoteTree;
+import com.framsticks.structure.Path;
+import com.framsticks.structure.Tree;
+import com.framsticks.util.ExceptionHandler;
 import com.framsticks.util.FramsticksException;
 import com.framsticks.util.dispatching.AbstractJoinable;
 import com.framsticks.util.dispatching.Dispatcher;
 import com.framsticks.util.dispatching.Dispatching;
-import com.framsticks.util.dispatching.ExceptionResultHandler;
-import com.framsticks.util.dispatching.Future;
+import com.framsticks.util.dispatching.FutureHandler;
 import com.framsticks.util.dispatching.Joinable;
 import com.framsticks.util.dispatching.JoinableCollection;
@@ -54,5 +55,5 @@
  */
 @FramsClassAnnotation
-public class Browser extends AbstractJoinable implements Dispatcher<Browser>, JoinableParent, ExceptionResultHandler {
+public class Browser extends AbstractJoinable implements Dispatcher<Browser>, JoinableParent, ExceptionHandler {
 
 	private static final Logger log = LogManager.getLogger(Browser.class);
@@ -213,5 +214,5 @@
 								file = new File("", new FileSource(filename));
 							} catch (IOException e) {
-								needFile.getFuture().handle(new FramsticksException().msg("failed to open choosed file").arg("filename", filename).cause(e));
+								needFile.getFuture().handle(new FramsticksException().msg("failed to open chosen file").arg("filename", filename).cause(e));
 							}
 							if (file != null) {
@@ -239,5 +240,5 @@
 	}
 
-	public void autoResolvePath(final String path, final Future<Path> future) {
+	public void autoResolvePath(final String path, final FutureHandler<Path> future) {
 		// final Tree i = trees.get("localhost");
 		// i.dispatch(new RunAt<Tree>(future) {
@@ -277,9 +278,9 @@
 			protected void runAt() {
 
-				for (final Tree i : trees) {
-					i.dispatch(new RunAt<Tree>(this) {
+				for (final Tree tree : trees) {
+					tree.dispatch(new RunAt<Tree>(this) {
 						@Override
 						protected void runAt() {
-							final Path p = Path.to(i, "/");
+							final Path p = Path.to(tree, "/");
 							log.debug("adding path: {}", p);
 							dispatch(new RunAt<Browser>(this) {
Index: java/main/src/main/java/com/framsticks/gui/Frame.java
===================================================================
--- java/main/src/main/java/com/framsticks/gui/Frame.java	(revision 103)
+++ java/main/src/main/java/com/framsticks/gui/Frame.java	(revision 105)
@@ -39,6 +39,4 @@
 import org.apache.logging.log4j.LogManager;
 
-import com.framsticks.core.Path;
-import com.framsticks.core.Tree;
 import com.framsticks.gui.tree.AbstractNode;
 import com.framsticks.gui.tree.MetaNode;
@@ -46,6 +44,8 @@
 import com.framsticks.gui.tree.TreeModel;
 import com.framsticks.gui.tree.TreeNode;
+import com.framsticks.structure.Path;
+import com.framsticks.structure.Tree;
 import com.framsticks.util.dispatching.Dispatching;
-import com.framsticks.util.dispatching.FutureHandler;
+import com.framsticks.util.dispatching.Future;
 import com.framsticks.util.dispatching.Joinable;
 import com.framsticks.util.dispatching.JoinableCollection;
@@ -269,5 +269,5 @@
 		if (!tree.getAssignedRoot().isResolved()) {
 			log.debug("root not yet assigned, geting root");
-			tree.get(path, new FutureHandler<Path>(this) {
+			tree.get(path, new Future<Path>(this) {
 
 				@Override
@@ -329,5 +329,5 @@
 	public void updatePanelIfIsLeadSelection(Path path) {
 		assert isActive();
-		TreePath treePath = treeModel.convertToTreePath(path, true);
+		TreePath treePath = treeModel.convertToTreePath(path);
 		if (treePath == null) {
 			return;
Index: java/main/src/main/java/com/framsticks/gui/FrameJoinable.java
===================================================================
--- java/main/src/main/java/com/framsticks/gui/FrameJoinable.java	(revision 103)
+++ java/main/src/main/java/com/framsticks/gui/FrameJoinable.java	(revision 105)
@@ -13,10 +13,10 @@
 import org.apache.logging.log4j.LogManager;
 
+import com.framsticks.util.ExceptionHandler;
 import com.framsticks.util.FramsticksException;
-import com.framsticks.util.dispatching.ExceptionResultHandler;
 import com.framsticks.util.dispatching.RunAt;
 import com.framsticks.util.dispatching.ThrowExceptionHandler;
 
-public abstract class FrameJoinable extends SwingJoinable<JFrame> implements ExceptionResultHandler {
+public abstract class FrameJoinable extends SwingJoinable<JFrame> implements ExceptionHandler {
 	private static final Logger log =
 		LogManager.getLogger(FrameJoinable.class);
Index: java/main/src/main/java/com/framsticks/gui/ModifiablePanel.java
===================================================================
--- java/main/src/main/java/com/framsticks/gui/ModifiablePanel.java	(revision 103)
+++ java/main/src/main/java/com/framsticks/gui/ModifiablePanel.java	(revision 105)
@@ -9,5 +9,6 @@
 import java.awt.event.ActionEvent;
 import java.awt.event.ActionListener;
-import static com.framsticks.core.TreeOperations.*;
+
+import static com.framsticks.structure.TreeOperations.*;
 
 /**
Index: java/main/src/main/java/com/framsticks/gui/MultiPanel.java
===================================================================
--- java/main/src/main/java/com/framsticks/gui/MultiPanel.java	(revision 103)
+++ java/main/src/main/java/com/framsticks/gui/MultiPanel.java	(revision 105)
@@ -1,6 +1,6 @@
 package com.framsticks.gui;
 
-import com.framsticks.core.Path;
 import com.framsticks.params.Access;
+import com.framsticks.structure.Path;
 
 import javax.swing.*;
Index: java/main/src/main/java/com/framsticks/gui/ObjectPanel.java
===================================================================
--- java/main/src/main/java/com/framsticks/gui/ObjectPanel.java	(revision 103)
+++ java/main/src/main/java/com/framsticks/gui/ObjectPanel.java	(revision 105)
@@ -1,5 +1,4 @@
 package com.framsticks.gui;
 
-import com.framsticks.core.Path;
 import com.framsticks.gui.controls.Control;
 import com.framsticks.gui.controls.ControlOwner;
@@ -16,9 +15,11 @@
 import java.util.HashMap;
 import java.util.Map;
+
+import static com.framsticks.structure.TreeOperations.*;
 import static com.framsticks.util.lang.Containers.filterInstanceof;
 
+import com.framsticks.structure.Path;
 import com.framsticks.util.FramsticksException;
 
-import static com.framsticks.core.TreeOperations.*;
 
 @SuppressWarnings("serial")
Index: java/main/src/main/java/com/framsticks/gui/PopupMenuEntryProvider.java
===================================================================
--- java/main/src/main/java/com/framsticks/gui/PopupMenuEntryProvider.java	(revision 103)
+++ java/main/src/main/java/com/framsticks/gui/PopupMenuEntryProvider.java	(revision 105)
@@ -3,5 +3,5 @@
 import javax.swing.JPopupMenu;
 
-import com.framsticks.core.Path;
+import com.framsticks.structure.Path;
 
 public interface PopupMenuEntryProvider {
Index: java/main/src/main/java/com/framsticks/gui/StandardPanelProvider.java
===================================================================
--- java/main/src/main/java/com/framsticks/gui/StandardPanelProvider.java	(revision 103)
+++ java/main/src/main/java/com/framsticks/gui/StandardPanelProvider.java	(revision 105)
@@ -19,9 +19,6 @@
 	public TreePanel providePanel(TreePanel.Parameters parameters) {
 		if (parameters.param instanceof ObjectParam) {
-			return new ObjectPanel(parameters, CollectionUtils.select(parameters.framsClass.getParamEntries(), new NotPredicate(new InstanceofPredicate(CompositeParam.class))));
+			return new ObjectPanel(parameters, CollectionUtils.select(parameters.framsClass.getParams(), new NotPredicate(new InstanceofPredicate(CompositeParam.class))));
 		}
-//		if (param instanceof ListParam) {
-//			return new ListPanel();
-//		}
 		return null;
 	}
Index: java/main/src/main/java/com/framsticks/gui/StatusBar.java
===================================================================
--- java/main/src/main/java/com/framsticks/gui/StatusBar.java	(revision 103)
+++ java/main/src/main/java/com/framsticks/gui/StatusBar.java	(revision 105)
@@ -13,16 +13,16 @@
 
 import com.framsticks.gui.controls.Control;
+import com.framsticks.util.ExceptionHandler;
 import com.framsticks.util.FramsticksException;
 import com.framsticks.util.dispatching.Dispatcher;
 import com.framsticks.util.dispatching.Dispatching;
-import com.framsticks.util.dispatching.ExceptionResultHandler;
 import com.framsticks.util.dispatching.RunAt;
 
-public class StatusBar implements ExceptionResultHandler {
+public class StatusBar implements ExceptionHandler {
 	private static final Logger log = LogManager.getLogger(StatusBar.class);
 
 	protected JTextField statusBar;
 	protected JPanel swing;
-	protected ExceptionResultHandler exceptionHandler;
+	protected ExceptionHandler exceptionHandler;
 	protected final Dispatcher<?> dispatcher;
 
@@ -86,5 +86,5 @@
 	 * @return the exceptionHandler
 	 */
-	public ExceptionResultHandler getExceptionHandler() {
+	public ExceptionHandler getExceptionHandler() {
 		return exceptionHandler;
 	}
@@ -93,5 +93,5 @@
 	 * @param exceptionHandler the exceptionHandler to set
 	 */
-	public void setExceptionHandler(ExceptionResultHandler exceptionHandler) {
+	public void setExceptionHandler(ExceptionHandler exceptionHandler) {
 		this.exceptionHandler = exceptionHandler;
 	}
Index: java/main/src/main/java/com/framsticks/gui/TreeAtFrame.java
===================================================================
--- java/main/src/main/java/com/framsticks/gui/TreeAtFrame.java	(revision 103)
+++ java/main/src/main/java/com/framsticks/gui/TreeAtFrame.java	(revision 105)
@@ -4,9 +4,4 @@
 import org.apache.logging.log4j.LogManager;
 
-import com.framsticks.core.SideNoteKey;
-import com.framsticks.core.Tree;
-import com.framsticks.core.Node;
-import com.framsticks.core.Path;
-import static com.framsticks.core.TreeOperations.*;
 import com.framsticks.gui.controls.ValueControl;
 import com.framsticks.params.CompositeParam;
@@ -15,8 +10,12 @@
 
 import java.util.*;
+import static com.framsticks.params.ParamsUtil.getParam;
+import static com.framsticks.structure.TreeOperations.*;
 
-
-
-import com.framsticks.util.dispatching.FutureHandler;
+import com.framsticks.structure.Node;
+import com.framsticks.structure.Path;
+import com.framsticks.structure.SideNoteKey;
+import com.framsticks.structure.Tree;
+import com.framsticks.util.dispatching.Future;
 
 /**
@@ -114,5 +113,5 @@
 
 		for (final Map.Entry<String, Object> e : userChanges.changes.entrySet()) {
-			set(path, getParam(path, e.getKey(), PrimitiveParam.class), e.getValue(), new FutureHandler<Integer>(frame) {
+			set(path, getParam(path, e.getKey(), PrimitiveParam.class), e.getValue(), new Future<Integer>(frame) {
 				@Override
 				protected void result(Integer flag) {
Index: java/main/src/main/java/com/framsticks/gui/TreePanel.java
===================================================================
--- java/main/src/main/java/com/framsticks/gui/TreePanel.java	(revision 103)
+++ java/main/src/main/java/com/framsticks/gui/TreePanel.java	(revision 105)
@@ -1,7 +1,6 @@
 package com.framsticks.gui;
 
-import com.framsticks.core.Path;
-import com.framsticks.core.Tree;
-import static com.framsticks.core.TreeOperations.*;
+import static com.framsticks.structure.TreeOperations.*;
+
 import com.framsticks.gui.tree.AbstractNode;
 import com.framsticks.gui.tree.TreeNode;
@@ -9,4 +8,6 @@
 import com.framsticks.params.CompositeParam;
 import com.framsticks.params.FramsClass;
+import com.framsticks.structure.Path;
+import com.framsticks.structure.Tree;
 import com.framsticks.util.lang.Casting;
 
Index: java/main/src/main/java/com/framsticks/gui/console/Console.java
===================================================================
--- java/main/src/main/java/com/framsticks/gui/console/Console.java	(revision 103)
+++ java/main/src/main/java/com/framsticks/gui/console/Console.java	(revision 105)
@@ -15,7 +15,7 @@
 import com.framsticks.gui.FrameJoinable;
 import com.framsticks.params.annotations.FramsClassAnnotation;
+import com.framsticks.util.ExceptionHandler;
 import com.framsticks.util.FramsticksException;
 import com.framsticks.util.dispatching.Dispatching;
-import com.framsticks.util.dispatching.ExceptionResultHandler;
 import com.framsticks.util.dispatching.Joinable;
 import com.framsticks.util.dispatching.JoinableParent;
@@ -89,6 +89,6 @@
 	}
 
-	protected ExceptionResultHandler getExceptionHandler() {
-		return new ExceptionResultHandler() {
+	protected ExceptionHandler getExceptionHandler() {
+		return new ExceptionHandler() {
 
 			@Override
Index: java/main/src/main/java/com/framsticks/gui/console/ManagedConsole.java
===================================================================
--- java/main/src/main/java/com/framsticks/gui/console/ManagedConsole.java	(revision 103)
+++ java/main/src/main/java/com/framsticks/gui/console/ManagedConsole.java	(revision 105)
@@ -10,6 +10,7 @@
 import com.framsticks.communication.Response;
 import com.framsticks.communication.queries.ApplicationRequest;
-import com.framsticks.core.Path;
-import static com.framsticks.core.TreeOperations.*;
+
+import static com.framsticks.structure.TreeOperations.*;
+
 import com.framsticks.gui.SwingDispatcher;
 import com.framsticks.params.CompositeParam;
@@ -18,7 +19,8 @@
 import com.framsticks.params.types.ListParam;
 import com.framsticks.remote.RemoteTree;
+import com.framsticks.structure.Path;
 import com.framsticks.util.FramsticksException;
 import com.framsticks.util.dispatching.Dispatching;
-import com.framsticks.util.dispatching.FutureHandler;
+import com.framsticks.util.dispatching.Future;
 import com.framsticks.util.dispatching.RunAt;
 import com.framsticks.util.lang.Casting;
@@ -98,5 +100,5 @@
 		// final Iterator<String> iterator = Path.splitPath(textual);
 
-		tryGet(tree, textual, new FutureHandler<Path>(this) {
+		tryGet(tree, textual, new Future<Path>(this) {
 
 			@Override
@@ -143,5 +145,5 @@
 
 				if (path.getTop().getParam() instanceof ListParam) {
-					tree.get(path, new FutureHandler<Path>(ManagedConsole.this) {
+					tree.get(path, new Future<Path>(ManagedConsole.this) {
 						@Override
 						protected void result(Path result) {
Index: java/main/src/main/java/com/framsticks/gui/controls/Control.java
===================================================================
--- java/main/src/main/java/com/framsticks/gui/controls/Control.java	(revision 103)
+++ java/main/src/main/java/com/framsticks/gui/controls/Control.java	(revision 105)
@@ -1,15 +1,12 @@
 package com.framsticks.gui.controls;
-
-// import java.awt.BorderLayout;
-
 
 import javax.swing.JPanel;
 
-import com.framsticks.core.Path;
 import com.framsticks.params.ParamFlags;
 import com.framsticks.params.Param;
+import com.framsticks.structure.Path;
+import com.framsticks.util.ExceptionHandler;
 import com.framsticks.util.FramsticksException;
 import com.framsticks.util.Misc;
-import com.framsticks.util.dispatching.ExceptionResultHandler;
 
 /**
@@ -17,5 +14,5 @@
  */
 @SuppressWarnings("serial")
-public abstract class Control extends JPanel implements ExceptionResultHandler {
+public abstract class Control extends JPanel implements ExceptionHandler {
 
 	public static final int LINE_HEIGHT = 36;
Index: java/main/src/main/java/com/framsticks/gui/controls/ControlOwner.java
===================================================================
--- java/main/src/main/java/com/framsticks/gui/controls/ControlOwner.java	(revision 103)
+++ java/main/src/main/java/com/framsticks/gui/controls/ControlOwner.java	(revision 105)
@@ -2,9 +2,9 @@
 
 
-import com.framsticks.core.Path;
 import com.framsticks.gui.Frame;
-import com.framsticks.util.dispatching.ExceptionResultHandler;
+import com.framsticks.structure.Path;
+import com.framsticks.util.ExceptionHandler;
 
-public interface ControlOwner extends ExceptionResultHandler {
+public interface ControlOwner extends ExceptionHandler {
 
 	public Path getCurrentPath();
Index: java/main/src/main/java/com/framsticks/gui/controls/EventControl.java
===================================================================
--- java/main/src/main/java/com/framsticks/gui/controls/EventControl.java	(revision 103)
+++ java/main/src/main/java/com/framsticks/gui/controls/EventControl.java	(revision 105)
@@ -10,6 +10,4 @@
 
 
-import com.framsticks.core.Path;
-import com.framsticks.core.SideNoteKey;
 import com.framsticks.gui.Frame;
 import com.framsticks.gui.Gui;
@@ -17,11 +15,13 @@
 import com.framsticks.params.EventListener;
 import com.framsticks.params.types.EventParam;
+import com.framsticks.structure.Path;
+import com.framsticks.structure.SideNoteKey;
 import com.framsticks.util.FramsticksUnsupportedOperationException;
 import com.framsticks.util.dispatching.Dispatching;
-import com.framsticks.util.dispatching.FutureHandler;
+import com.framsticks.util.dispatching.Future;
 import com.framsticks.util.dispatching.RunAt;
 import com.framsticks.util.lang.Pair;
 
-import static com.framsticks.core.TreeOperations.*;
+import static com.framsticks.structure.TreeOperations.*;
 
 /**
@@ -59,5 +59,5 @@
 					removeSideNote(path, listenerKey);
 					refreshState();
-					path.getTree().removeListener(path, getParam(), listener, FutureHandler.doNothing(Void.class, owner.getFrame()));
+					path.getTree().removeListener(path, getParam(), listener, Future.doNothing(Void.class, owner.getFrame()));
 					return;
 				}
@@ -79,5 +79,5 @@
 				};
 
-				path.getTree().addListener(path, getParam(), newListener, Object.class, new FutureHandler<Void>(owner.getFrame()) {
+				addListener(path, getParam(), newListener, Object.class, new Future<Void>(owner.getFrame()) {
 
 					@Override
Index: java/main/src/main/java/com/framsticks/gui/controls/ProcedureControl.java
===================================================================
--- java/main/src/main/java/com/framsticks/gui/controls/ProcedureControl.java	(revision 103)
+++ java/main/src/main/java/com/framsticks/gui/controls/ProcedureControl.java	(revision 105)
@@ -1,10 +1,10 @@
 package com.framsticks.gui.controls;
 
-import com.framsticks.core.Path;
 import com.framsticks.gui.Frame;
 import com.framsticks.gui.Gui;
 import com.framsticks.params.Param;
 import com.framsticks.params.types.ProcedureParam;
-import com.framsticks.util.dispatching.FutureHandler;
+import com.framsticks.structure.Path;
+import com.framsticks.util.dispatching.Future;
 
 import javax.swing.*;
@@ -73,5 +73,5 @@
 		assert path.getTree().isActive();
 
-		path.getTree().call(path, param, arguments, Object.class, new FutureHandler<Object>(frame) {
+		path.getTree().call(path, param, arguments, Object.class, new Future<Object>(frame) {
 
 			@Override
Index: java/main/src/main/java/com/framsticks/gui/table/ListPanel.java
===================================================================
--- java/main/src/main/java/com/framsticks/gui/table/ListPanel.java	(revision 103)
+++ java/main/src/main/java/com/framsticks/gui/table/ListPanel.java	(revision 105)
@@ -44,5 +44,5 @@
 			}
 		} else {
-			for (Param param : framsClass.getParamEntries()) {
+			for (Param param : framsClass.getParams()) {
 				if (provider.getMaximumColumnNumber() != null && tableModel.getColumnCount() >= provider.getMaximumColumnNumber()) {
 					break;
Index: java/main/src/main/java/com/framsticks/gui/table/ProcedureColumn.java
===================================================================
--- java/main/src/main/java/com/framsticks/gui/table/ProcedureColumn.java	(revision 103)
+++ java/main/src/main/java/com/framsticks/gui/table/ProcedureColumn.java	(revision 105)
@@ -1,9 +1,10 @@
 package com.framsticks.gui.table;
 
-
-import com.framsticks.core.Path;
 import com.framsticks.gui.controls.ProcedureControl;
 import com.framsticks.params.CompositeParam;
 import com.framsticks.params.types.ProcedureParam;
+import com.framsticks.structure.Path;
+
+import static com.framsticks.params.ParamsUtil.arguments;
 
 public class ProcedureColumn extends Column {
@@ -38,5 +39,5 @@
 			return 0;
 		}
-		ProcedureControl.callProcedure(path, getParam(), new Object[] {}, tableModel.getFrame());
+		ProcedureControl.callProcedure(path, getParam(), arguments(), tableModel.getFrame());
 		return 0;
 	}
Index: java/main/src/main/java/com/framsticks/gui/tree/TreeModel.java
===================================================================
--- java/main/src/main/java/com/framsticks/gui/tree/TreeModel.java	(revision 103)
+++ java/main/src/main/java/com/framsticks/gui/tree/TreeModel.java	(revision 105)
@@ -14,10 +14,4 @@
 import org.apache.logging.log4j.LogManager;
 
-import com.framsticks.core.ListChange;
-import com.framsticks.core.Node;
-import com.framsticks.core.Path;
-import com.framsticks.core.SideNoteKey;
-import com.framsticks.core.TreeOperations;
-import com.framsticks.core.ValueChange;
 import com.framsticks.gui.Frame;
 import com.framsticks.params.Access;
@@ -29,11 +23,16 @@
 import com.framsticks.params.ValueParam;
 import com.framsticks.params.types.EventParam;
-import com.framsticks.util.FramsticksException;
+import com.framsticks.structure.Node;
+import com.framsticks.structure.Path;
+import com.framsticks.structure.SideNoteKey;
+import com.framsticks.structure.TreeOperations;
+import com.framsticks.structure.messages.ListChange;
+import com.framsticks.structure.messages.ValueChange;
 import com.framsticks.util.Misc;
 import com.framsticks.util.FramsticksUnsupportedOperationException;
-import com.framsticks.util.dispatching.FutureHandler;
+import com.framsticks.util.dispatching.Future;
 import com.framsticks.util.lang.Casting;
 
-import static com.framsticks.core.TreeOperations.*;
+import static com.framsticks.structure.TreeOperations.*;
 
 public class TreeModel implements javax.swing.tree.TreeModel {
@@ -42,5 +41,4 @@
 
 	protected List<TreeModelListener> listeners = new LinkedList<>();
-
 
 	protected final Frame frame;
@@ -208,5 +206,5 @@
 	}
 
-	public TreePath convertToTreePath(Path path, boolean forceComplete) {
+	public TreePath convertToTreePath(Path path) {
 		assert frame.isActive();
 
@@ -271,8 +269,8 @@
 			return;
 		}
-		path.getTree().get(path, new FutureHandler<Path>(frame) {
+		path.getTree().get(path, new Future<Path>(frame) {
 			@Override
 			protected void result(Path result) {
-				final TreePath treePath = convertToTreePath(result, true);
+				final TreePath treePath = convertToTreePath(result);
 
 
@@ -358,8 +356,5 @@
 
 					log.debug("reacting to change {} in {}", listChange, listPath);
-					final TreePath treeListPath = convertToTreePath(listPath, true);
-					if (treeListPath == null) {
-						throw new FramsticksException().msg("path was not fully converted").arg("path", listPath);
-					}
+					final TreePath treeListPath = convertToTreePath(listPath);
 
 					if ((listChange.getAction().equals(ListChange.Action.Modify)) && (listChange.getPosition() == -1)) {
@@ -387,5 +382,5 @@
 							}
 
-							listPath.getTree().get(childPath, new FutureHandler<Path>(frame) {
+							listPath.getTree().get(childPath, new Future<Path>(frame) {
 								@Override
 								protected void result(Path result) {
@@ -394,5 +389,5 @@
 									}
 									assert frame.isActive();
-									final TreePath treePath = Misc.throwIfNull(frame.getTreeModel().convertToTreePath(result, true));
+									final TreePath treePath = Misc.throwIfNull(frame.getTreeModel().convertToTreePath(result));
 
 									// treeModel.nodeStructureChanged(treePath);
@@ -420,5 +415,5 @@
 						case Modify: {
 							Path childPath = listPath.appendParam(access.prepareParamFor(id)).tryResolveIfNeeded();
-							listPath.getTree().get(childPath, new FutureHandler<Path>(frame) {
+							listPath.getTree().get(childPath, new Future<Path>(frame) {
 								@Override
 								protected void result(Path result) {
Index: java/main/src/main/java/com/framsticks/gui/tree/TreeNode.java
===================================================================
--- java/main/src/main/java/com/framsticks/gui/tree/TreeNode.java	(revision 103)
+++ java/main/src/main/java/com/framsticks/gui/tree/TreeNode.java	(revision 105)
@@ -8,8 +8,4 @@
 import org.apache.logging.log4j.Logger;
 
-import com.framsticks.core.Node;
-import com.framsticks.core.Path;
-import com.framsticks.core.SideNoteKey;
-import com.framsticks.core.Tree;
 import com.framsticks.gui.Frame;
 import com.framsticks.gui.ImageProvider;
@@ -19,16 +15,19 @@
 import com.framsticks.params.CompositeParam;
 import com.framsticks.params.EventListener;
-import com.framsticks.params.FramsClass;
 import com.framsticks.params.ValueParam;
 import com.framsticks.params.types.EventParam;
 import com.framsticks.params.types.ObjectParam;
 import com.framsticks.params.types.StringParam;
+import com.framsticks.structure.Node;
+import com.framsticks.structure.Path;
+import com.framsticks.structure.SideNoteKey;
+import com.framsticks.structure.Tree;
 import com.framsticks.util.FramsticksException;
-import com.framsticks.util.dispatching.FutureHandler;
+import com.framsticks.util.dispatching.Future;
 import com.framsticks.util.lang.Casting;
 import com.framsticks.util.lang.Containers;
 import com.framsticks.util.swing.TooltipConstructor;
 
-import static com.framsticks.core.TreeOperations.*;
+import static com.framsticks.structure.TreeOperations.*;
 
 public class TreeNode extends AbstractNode {
@@ -69,11 +68,10 @@
 		if (path.getTop().getParam() instanceof ObjectParam) {
 			Access access = bindAccess(path);
-			FramsClass framsClass = access.getFramsClass();
-			for (EventParam eventParam : Containers.filterInstanceof(framsClass.getParamEntries(), EventParam.class)) {
+			for (EventParam eventParam : Containers.filterInstanceof(access.getParams(), EventParam.class)) {
 				if (!eventParam.getId().endsWith("_changed")) {
 					continue;
 				}
 				String valueId = eventParam.getId().substring(0, eventParam.getId().length() - 8);
-				final ValueParam valueParam = Casting.tryCast(ValueParam.class, framsClass.getParam(valueId));
+				final ValueParam valueParam = Casting.tryCast(ValueParam.class, access.getParam(valueId));
 				if (valueParam == null) {
 					continue;
@@ -249,5 +247,5 @@
 
 		renderer.setToolTipText(new TooltipConstructor()
-				.append("frams", access.getId())
+				.append("frams", access.getTypeId())
 				.append("java", child.getClass().getCanonicalName())
 				.append("access", access.getClass().getSimpleName())
@@ -271,5 +269,5 @@
 
 	protected <A> void tryAddListener(final Path path, final EventParam eventParam, Class<A> argumentType, final EventListener<A> listener) {
-		getTree().addListener(path, eventParam, listener, argumentType, new FutureHandler<Void>(getFrame()) {
+		addListener(path, eventParam, listener, argumentType, new Future<Void>(getFrame()) {
 			@SuppressWarnings("unchecked")
 			@Override
Index: java/main/src/main/java/com/framsticks/hosting/Cli.java
===================================================================
--- java/main/src/main/java/com/framsticks/hosting/Cli.java	(revision 103)
+++ java/main/src/main/java/com/framsticks/hosting/Cli.java	(revision 105)
@@ -9,11 +9,12 @@
 import com.framsticks.communication.Response;
 import com.framsticks.communication.ServerSideResponseFuture;
-import com.framsticks.core.Path;
-import com.framsticks.core.Tree;
 import com.framsticks.params.EventListener;
 import com.framsticks.params.annotations.FramsClassAnnotation;
 import com.framsticks.params.annotations.ParamAnnotation;
 import com.framsticks.params.types.EventParam;
-import com.framsticks.util.dispatching.FutureHandler;
+import com.framsticks.structure.Path;
+import com.framsticks.structure.Tree;
+import com.framsticks.structure.TreeOperations;
+import com.framsticks.util.dispatching.Future;
 import com.framsticks.util.dispatching.ThrowExceptionHandler;
 
@@ -69,8 +70,8 @@
 
 		// SyncedFuture handler = new SyncedFuture<Void>(ThrowExceptionHandler.getInstance());
-		path.getTree().addListener(path, param, event.listener, Object.class, FutureHandler.doNothing(Void.class, ThrowExceptionHandler.getInstance()));
+		TreeOperations.addListener(path, param, event.listener, Object.class, Future.doNothing(Void.class, ThrowExceptionHandler.getInstance()));
 
 		events.put(event.id, event);
-		responseFuture.pass(new Response(true, event.pathToEvent, null));
+		responseFuture.pass(new Response(true, event.pathToEvent));
 		// handler
 	}
Index: java/main/src/main/java/com/framsticks/hosting/CliEvent.java
===================================================================
--- java/main/src/main/java/com/framsticks/hosting/CliEvent.java	(revision 103)
+++ java/main/src/main/java/com/framsticks/hosting/CliEvent.java	(revision 105)
@@ -1,5 +1,4 @@
 package com.framsticks.hosting;
 
-import com.framsticks.core.Path;
 import com.framsticks.params.EventListener;
 import com.framsticks.params.annotations.FramsClassAnnotation;
@@ -7,5 +6,6 @@
 import com.framsticks.params.types.EventParam;
 import com.framsticks.params.types.ProcedureParam;
-import com.framsticks.util.dispatching.FutureHandler;
+import com.framsticks.structure.Path;
+import com.framsticks.util.dispatching.Future;
 import com.framsticks.util.dispatching.ThrowExceptionHandler;
 
@@ -32,5 +32,5 @@
 
 		//it should happen now
-		path.getTree().removeListener(path, param, listener, FutureHandler.doNothing(Void.class, ThrowExceptionHandler.getInstance()));
+		path.getTree().removeListener(path, param, listener, Future.doNothing(Void.class, ThrowExceptionHandler.getInstance()));
 		cli.events.remove(id);
 	}
